#----------------
# 関数の定義
#----------------
# ベクトルの０クリア
def vec(vname, rmax, inval=0):
    vname = [number for number in range(int(rmax))]
    for i in range(int(rmax)):
        vname[int(i)] = inval
    return vname

# マトリクスの０クリア
def mat(mname, rmax1, rmax2, inval=0):
    mname = [number for number in range(int(rmax1))]
    for i in range(int(rmax1)):
        mname[int(i)] = [number for number in range(int(rmax2))]
        for j in range(int(rmax2)):
            mname[int(i)][int(j)] = inval
    return mname

#連立方程式の解法
def solveSE(A,B,n):
    n1 = n - 1
    if n1 == 0 :
        B[0]=B[0]/A[0][0]
        return B
    for k in range(n1):
        k1 = k + 1
        s = A[k][k]
        for j in range(k1,n):
            A[k][j] = A[k][j]/s
        B[k] = B[k]/s
        for i in range(k1,n):
            c = A[i][k]
            for j in range(k1,n):
                A[i][j] = A[i][j] - c*A[k][j]
            B[i] = B[i] - c*B[k]
    B[n-1] = B[n-1]/A[n-1][n-1]
    for m in range(n1):
        k = (n-1) - (m+1)
        k1 = k + 1
        for j in range(k1,n):
            B[k] = B[k] - A[k][j]*B[j]
    return B

#----------------
# データ入力
#----------------

#節点数の入力
nod = input("Number of node =")
nod = int(nod)
ndg = 1

#座標入力
x = []
x = vec(x,nod,0.0)
for i in range(nod):
    x[i] = float(input("x = "))

#境界条件
idg = []
idg = vec(idg,nod*ndg,0)
idg[0]=1

#荷重条件
fg = []
fg = vec(fg,nod*ndg,0.0)
fg[nod-1] = float( input("Fx = ") )

#要素情報
nel = nod-1
nnd = 2
indv = []
indv = mat(indv,nel,2,0)
for i in range(nel):
    indv[i][0]=i
    indv[i][1]=i+1

#ヤング係数の入力
E = float( input("E = ") )

#断面積の入力
A = []
A = vec(A,nel,0.0)
for i in range(nel):
    A[i] = float( input("A = ") )

#----------------
# 有限要素解析
#----------------
#全体剛性マトリクスの作成
kg = []
kg = mat(kg,nod*ndg,nod*ndg,0.0)
ke = []
ke = mat(ke,2,2,0.0)

for n in range(nel):
    L = x[indv[n][1]]-x[indv[n][0]]
    ke[0][0] = E*A[n]/L
    ke[0][1] =-E*A[n]/L
    ke[1][0] =-E*A[n]/L
    ke[1][1] = E*A[n]/L
    for i in range(nnd):
        for j in range(nnd):
            ig = indv[n][i]
            jg = indv[n][j]
            kg[ig][jg] = kg[ig][jg] + ke[i][j]

#変位拘束点以外の行列の抽出
ic = -1
for i in range(nod):
    if idg[i] == 0:
        ic = ic + 1
        fg[ic] = fg[i]
        jc = -1
        for j in range(nod):
            if idg[j] == 0:
                jc = jc + 1
                kg[ic][jc] = kg[i][j]

#連立方程式の解法
kgc = []
kgc = mat(kgc,ic+1,ic+1,0.0)
fgc = []
fgc = vec(fgc,ic+1,0.0)

for i in range(ic+1):
    fgc[i]=fg[i]
    for j in range(jc+1):
        kgc[i][j]=kg[i][j]

dgc = []
dgc = vec(dgc,ic+1,0.0)
dgc = solveSE(kgc,fgc,ic+1)

#節点変位の出力
dg = []
dg = vec(dg,nod,0.0)
ic = -1
for i in range(nod):
    if idg[i] == 0 :
        ic = ic + 1
        dg[i] = dgc[ic]

print('displacement of node = ',dg)

#要素軸力の計算と出力
#Nf = np.zeros(nel)
Nf = []
Nf = vec(Nf,nel,0.0)
for n in range(nel):
    Nf[n] = -E*A[n]/L*( dg[indv[n][0]] - dg[indv[n][1]] )

print('N = ',Nf)