import math
#----------------
# 関数の定義
#----------------
# ベクトルの０クリア
def vec(vname, rmax, inval=0):
    vname = [number for number in range(int(rmax))]
    for i in range(int(rmax)):
        vname[int(i)] = inval
    return vname

# マトリクスの０クリア
def mat(mname, rmax1, rmax2, inval=0):
    mname = [number for number in range(int(rmax1))]
    for i in range(int(rmax1)):
        mname[int(i)] = [number for number in range(int(rmax2))]
        for j in range(int(rmax2)):
            mname[int(i)][int(j)] = inval
    return mname

#連立方程式の解法
def solveSE(A,B,n):
    n1 = n - 1
    if n1 == 0 :
        B[0]=B[0]/A[0][0]
        return B
    for k in range(n1):
        k1 = k + 1
        s = A[k][k]
        for j in range(k1,n):
            A[k][j] = A[k][j]/s
        B[k] = B[k]/s
        for i in range(k1,n):
            c = A[i][k]
            for j in range(k1,n):
                A[i][j] = A[i][j] - c*A[k][j]
            B[i] = B[i] - c*B[k]
    B[n-1] = B[n-1]/A[n-1][n-1]
    for m in range(n1):
        k = (n-1) - (m+1)
        k1 = k + 1
        for j in range(k1,n):
            B[k] = B[k] - A[k][j]*B[j]
    return B
#----------------
# データ入力
#----------------
file = open('input2.txt','r')
fileout = open('output2.txt','w')

nod = file.readline()
nod = int(nod)
ndg = 2

X = []
X = vec(X,nod,0.0)
Y = []
Y = vec(Y,nod,0.0)
idg = []
idg = vec(idg,nod*ndg,0)
fg = []
fg = vec(fg,nod*ndg,0.0)
dg = []
dg = vec(dg,nod*ndg,0.0)
kg = []
kg = mat(kg,nod*ndg,nod*ndg,0.0)

#座標入力
for i in range(nod):
   xd = file.readline()
   d1,d2 = xd.split(',')
   X[i] = float(d1)
   Y[i] = float(d2)

#拘束情報の入力
ncn = file.readline()
ncn = int(ncn)
for i in range(ncn):
    bcn = file.readline()
    icn,ic1,ic2 = bcn.split(',')
    icn = int(icn)
    idg[ndg*(icn-1)+0] = int(ic1)
    idg[ndg*(icn-1)+1] = int(ic2)

#荷重情報の入力
nld = file.readline()
nld = int(nld)
for i in range(nld):
    fd = file.readline()
    ild,f1,f2 = fd.split(',')
    ild = int(ild)
    fg[ndg*(ild-1)+0] = float(f1)
    fg[ndg*(ild-1)+1] = float(f2)

#*** 要素情報の入力 ***
nel = file.readline()
nel = int(nel)
nnd = 2

indv = []
indv = mat(indv,nel,nnd,0)
A = []
A = vec(A,nel,0.0)

#要素のi端とj端の節点番号の入力
for i in range(nel):
    ind = file.readline()
    i1,i2 = ind.split(',')
    indv[i][0] = int(i1) - 1
    indv[i][1] = int(i2) - 1

#ヤング係数の入力
E = file.readline()
E = float(E)

#断面積の入力
for i in range(nel):
    d1 = file.readline()
    A[i] = float(d1)

file.close()

#入力データの出力
tl = 'Nod no.'+'      x      ' + '     y     '+'  bc_x  bc_y   '+'   fx        fy '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nod):
    s = str((' %5d' % (i+1)))+str('  %10.3e' % X[i])+str('  %10.3e' % Y[i])  \
      + str(' %5d' % idg[ndg*i+0]) + str(' %5d' % idg[ndg*i+1])  \
      + str('   %10.3e' % fg[ndg*i+0])+ str(' %10.3e' % fg[ndg*i+1])
    print(s)
    fileout.write(s)
    fileout.write('\n')

fileout.write('\n')
tl = 'Elm no.'+'    i     ' + ' j   '+'    E    '+'      A     '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nel):
    s = str(' %5d' % (i+1)) +str(' %5d' % (indv[i][0]+1)) +str('  %5d' % (indv[i][1]+1)) \
    + str('  %10.3e' % E) + str('  %10.3e' % A[i])
    print(s)
    fileout.write(s)
    fileout.write('\n')

#----------------
# 有限要素解析
#----------------
#全体剛性マトリクスの作成
kg = []
kg = mat(kg,nod*ndg,nod*ndg,0.0)
ke = []
ke = mat(ke,nnd*ndg,nnd*ndg,0.0)

for n in range(nel):
    i1 = indv[n][0]
    i2 = indv[n][1]
    L = math.sqrt((X[i2]-X[i1]) ** 2 + (Y[i2]-Y[i1]) ** 2)
    cs = (X[i2]-X[i1])/L
    sn = (Y[i2]-Y[i1])/L
    ke[0][0] = E*A[n]/L*cs**2
    ke[0][1] = E*A[n]/L*cs*sn
    ke[0][2] =-E*A[n]/L*cs**2
    ke[0][3] =-E*A[n]/L*cs*sn
    ke[1][0] = ke[0][1]
    ke[1][1] = E*A[n]/L*sn**2
    ke[1][2] =-E*A[n]/L*cs*sn
    ke[1][3] =-E*A[n]/L*sn**2
    ke[2][0] = ke[0][2]
    ke[2][1] = ke[1][2]
    ke[2][2] = E*A[n]/L*cs**2
    ke[2][3] = E*A[n]/L*cs*sn
    ke[3][0] = ke[0][3]
    ke[3][1] = ke[1][3]
    ke[3][2] = ke[2][3]
    ke[3][3] = E*A[n]/L*sn**2
    for ip in range(nnd):
        for i in range(ndg):
            ie = ndg*ip+i
            ig = ndg*indv[n][ip]+i
            for jp in range(nnd):
                for j in range(ndg):
                    je = ndg*jp+j
                    jg = ndg*indv[n][jp]+j
                    kg[ig][jg] = kg[ig][jg] + ke[ie][je]

#変位拘束点以外の行列の抽出
ic = 0
for i in range(nod*ndg):
    if idg[i]==0:
        ic = ic+1
kgc = []
kgc = mat(kgc,ic,ic,0.0)
fgc = []
fgc = vec(fgc,ic,0.0)
dgc = []
dgc = vec(dgc,ic,0.0)

ic = -1
for i in range(nod*ndg):
    if idg[i]==0:
        ic = ic+1
        fgc[ic]=fg[i]
        jc = -1
        for j in range(nod*ndg):
            if idg[j]==0:
                jc = jc + 1
                kgc[ic][jc]=kg[i][j]

#連立方程式の解法
dgc = solveSE(kgc,fgc,ic+1)

#節点変位の出力
dg = []
dg = vec(dg,nod*ndg,0.0)

ic = -1
for i in range(nod*ndg):
    if idg[i] == 0 :
        ic = ic + 1
        dg[i] = dgc[ic]

fileout.write('\n')
s = '-- displacement --'
print(s)
fileout.write(s)
fileout.write('\n')
tl = 'Nod no.'+'      u      ' + '     v     '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nod):
    s = str(' %5d' % (i+1))+str('  %10.3e' % dg[ndg*i+0])+str('  %10.3e' % dg[ndg*i+1])
    print(s)
    fileout.write(s)
    fileout.write('\n')

#軸力の計算と出力
Nf = []
Nf = vec(Nf,nel,0.0)

for n in range(nel):
    i1 = indv[n][0]
    i2 = indv[n][1]
    L = math.sqrt((X[i2]-X[i1]) ** 2 + (Y[i2]-Y[i1]) ** 2)
    cs = (X[i2]-X[i1])/L
    sn = (Y[i2]-Y[i1])/L
    ui = cs * dg[ndg * i1 + 0] + sn * dg[ndg * i1 + 1]
    uj = cs * dg[ndg * i2 + 0] + sn * dg[ndg * i2 + 1]
    fxi = E * A[n] / L * (ui - uj)
    Nf[n] = - fxi

s = '-- Stress (N) --'
print(s)
fileout.write(s)
fileout.write('\n')
tl = 'Elm no.'+'      N      '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nel):
    s = str(' %5d' % (i+1)) + str('   %10.3e' % Nf[i])
    print(s)
    fileout.write(s)
    fileout.write('\n')