import math

#----------------
# 関数の定義
#----------------
# ベクトルの０クリア
def vec(vname, rmax, inval=0):
    vname = [number for number in range(int(rmax))]
    for i in range(int(rmax)):
        vname[int(i)] = inval
    return vname

# マトリクスの０クリア
def mat(mname, rmax1, rmax2, inval=0):
    mname = [number for number in range(int(rmax1))]
    for i in range(int(rmax1)):
        mname[int(i)] = [number for number in range(int(rmax2))]
        for j in range(int(rmax2)):
            mname[int(i)][int(j)] = inval
    return mname

#連立方程式の解法
def solveSE(A,B,n):
    n1 = n - 1
    if n1 == 0 :
        B[0]=B[0]/A[0][0]
        return B
    for k in range(n1):
        k1 = k + 1
        s = A[k][k]
        for j in range(k1,n):
            A[k][j] = A[k][j]/s
        B[k] = B[k]/s
        for i in range(k1,n):
            c = A[i][k]
            for j in range(k1,n):
                A[i][j] = A[i][j] - c*A[k][j]
            B[i] = B[i] - c*B[k]
    B[n-1] = B[n-1]/A[n-1][n-1]
    for m in range(n1):
        k = (n-1) - (m+1)
        k1 = k + 1
        for j in range(k1,n):
            B[k] = B[k] - A[k][j]*B[j]
    return B

# 行列のかけ算
def mat_multi(C,A,B,n):
    for i in range(n):
        for j in range(n):
            s = 0.0
            for k in range(n):
                s = s + A[i][k]*B[k][j]
            C[i][j] = s
    return C

# 転置行列
def mat_T(C,A,n):
    for i in range(n):
        for j in range(n):
            C[j][i] = A[i][j]
    return C
#----------------
# データ入力
#----------------
file = open('input3.txt','r')
fileout = open('output3.txt','w')

nod = file.readline()
nod = int(nod)
ndg = 3

X = []
X = vec(X,nod,0.0)
Y = []
Y = vec(Y,nod,0.0)
idg = []
idg = vec(idg,nod*ndg,0)
fg = []
fg = vec(fg,nod*ndg,0.0)
dg = []
dg = vec(dg,nod*ndg,0.0)
kg = []
kg = mat(kg,nod*ndg,nod*ndg,0.0)

#座標入力
for i in range(nod):
   xd = file.readline()
   d1,d2 = xd.split(',')
   X[i] = float(d1)
   Y[i] = float(d2)

#拘束情報の入力
ncn = file.readline()
ncn = int(ncn)
for i in range(ncn):
    bcn = file.readline()
    icn,ic1,ic2,ic3 = bcn.split(',')
    icn = int(icn)
    idg[ndg*(icn-1)+0] = int(ic1)
    idg[ndg*(icn-1)+1] = int(ic2)
    idg[ndg*(icn-1)+2] = int(ic3)

#荷重情報の入力
nld = file.readline()
nld = int(nld)
for i in range(nld):
    fd = file.readline()
    ild,f1,f2,f3 = fd.split(',')
    ild = int(ild)
    fg[ndg*(ild-1)+0] = float(f1)
    fg[ndg*(ild-1)+1] = float(f2)
    fg[ndg*(ild-1)+2] = float(f3)

#*** 要素情報の入力 ***
nel = file.readline()
nel = int(nel)
nnd = 2

indv = []
indv = mat(indv,nel,nnd,0)
A = []
A = vec(A,nel,0.0)
Iz = []
Iz = vec(Iz,nel,0.0)
Cij = []
Cij = vec(Cij,nel,0.0)
Cji = []
Cji = vec(Cji,nel,0.0)
Q0i = []
Q0i = vec(Q0i,nel,0.0)
Q0j = []
Q0j = vec(Q0j,nel,0.0)
M0 = []
M0 = vec(M0,nel,0.0)

#要素のi端とj端の節点番号の入力
for i in range(nel):
    ind = file.readline()
    i1,i2 = ind.split(',')
    indv[i][0] = int(i1) - 1
    indv[i][1] = int(i2) - 1

#ヤング係数の入力
E = file.readline()
E = float(E)

#断面積、断面２次モーメントの入力
for i in range(nel):
    s = file.readline()
    s1,s2 = s.split(',')
    A[i] = float(s1)
    Iz[i] = float(s2)

#要素内荷重の入力
npl = file.readline()
npl = int(npl)
for i in range(npl):
    s = file.readline()
    n,s1,s2,s3,s4,s5 = s.split(',')
    n = int(n)-1
    Cij[n] = float(s1)
    Cji[n] = float(s2)
    Q0i[n] = float(s3)
    Q0j[n] = float(s4)
    M0[n]  = float(s5)
    Q0i[n]=-Q0i[n]
    Q0j[n]=-Q0j[n]
    i1 = indv[n][0]
    i2 = indv[n][1]
    L = math.sqrt((X[i2]-X[i1]) ** 2 + (Y[i2]-Y[i1]) ** 2)
    cs = (X[i2] - X[i1]) / L
    sn = (Y[i2] - Y[i1]) / L
    fg[ndg * i1 + 0]= fg[ndg * i1 + 0] - sn * Q0i[n]
    fg[ndg * i1 + 1] = fg[ndg * i1 + 1] + cs * Q0i[n]
    fg[ndg * i1 + 2] = fg[ndg * i1 + 2] + Cij[n]
    fg[ndg * i2 + 0] = fg[ndg * i2 + 0] - sn * Q0j[n]
    fg[ndg * i2 + 1] = fg[ndg * i2 + 1] + cs * Q0j[n]
    fg[ndg * i2 + 2] = fg[ndg * i2 + 2] + Cji[n]

file.close()

#入力データの出力
tl = 'Nod no.'+'      x      ' + '     y     '+'   bcx   bcy  bcth    '+'    fx         fy         M'
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nod):
    s = str((' %5d' % (i+1)))+str('  %10.3e' % X[i])+str('  %10.3e' % Y[i])  \
      + str(' %5d' % idg[ndg*i+0]) + str(' %5d' % idg[ndg*i+1]) + str(' %5d' % idg[ndg*i+2])  \
      + str('    %10.3e' % fg[ndg*i+0]) + str(' %10.3e' % fg[ndg*i+1]) + str(' %10.3e' % fg[ndg*i+2])
    print(s)
    fileout.write(s)
    fileout.write('\n')

tl = 'Elm no.'+'    i     ' + ' j   '+'    E    '+'       A     '+'      Iz      '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nel):
    s = str(' %5d' % (i+1)) + str(' %5d' % (indv[i][0]+1)) + str('  %5d' % (indv[i][1]+1)) \
    + str('  %10.3e' % E) + str('  %10.3e' % A[i]) + str('  %10.3e' % Iz[i])
    print(s)
    fileout.write(s)
    fileout.write('\n')

tl = 'Elm no.'+'      Cij     ' + '     Cij    '+'    Q0i    '+'     Q0j     '+'    M0      '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nel):
    s = str(' %5d' % (i+1)) + str('  %10.3e' % Cij[i]) + str('  %10.3e' % Cji[i]) \
    + str('  %10.3e' % Q0i[i]) + str('  %10.3e' % Q0j[i]) + str('  %10.3e' % M0[i])
    print(s)
    fileout.write(s)
    fileout.write('\n')

#----------------
# 有限要素解析
#----------------
#全体剛性マトリクスの作成
kg = []
kg = mat(kg,nod*ndg,nod*ndg,0.0)
ke = []
ke = mat(ke,nnd*ndg,nnd*ndg,0.0)
Tr = []
Tr = mat(Tr,nod*ndg,nod*ndg,0.0)
TrT = []
TrT = mat(TrT,nod*ndg,nod*ndg,0.0)
Tke = []
Tke = mat(Tke,nod*ndg,nod*ndg,0.0)
TkT = []
TkT= mat(TkT,nod*ndg,nod*ndg,0.0)

for n in range(nel):
    i1 = indv[n][0]
    i2 = indv[n][1]
    L = math.sqrt((X[i2]-X[i1]) ** 2 + (Y[i2]-Y[i1]) ** 2)
    cs = (X[i2]-X[i1])/L
    sn = (Y[i2]-Y[i1])/L
#座標変換マトリクス
    Tr[0][0] = cs
    Tr[0][1] = sn
    Tr[1][0] = -sn
    Tr[1][1] = cs
    Tr[2][2] = 1.0
    Tr[3][3] = cs
    Tr[3][4] = sn
    Tr[4][3] = -sn
    Tr[4][4] = cs
    Tr[5][5] = 1.0
#要素剛性マトリクス
    cx = E * A[n] / L
    ke[0][0] = cx
    ke[0][3] = -cx
    ke[3][0] = -cx
    ke[3][3] = cx
    cy = E * Iz[n] / L ** 3
    ke[1][1] = 12.0 * cy
    ke[1][2] = 6.0 * L * cy
    ke[1][4] = -12.0 * cy
    ke[1][5] = 6.0 * L * cy
    ke[2][1] = ke[1][2]
    ke[2][2] = 4.0 * L ** 2 * cy
    ke[2][4] = -6.0 * L * cy
    ke[2][5] = 2.0 * L ** 2 * cy
    ke[4][1] = ke[1][4]
    ke[4][2] = ke[2][4]
    ke[4][4] = 12.0 * cy
    ke[4][5] = -6.0 * L * cy
    ke[5][1] = ke[1][5]
    ke[5][2] = ke[2][5]
    ke[5][4] = ke[4][5]
    ke[5][5] = 4.0 * L ** 2 * cy

#座標変換
    TrT = mat_T(TrT,Tr,nnd*ndg)
    Tke = mat_multi(Tke,TrT,ke,nnd*ndg)
    TkT = mat_multi(TkT,Tke,Tr,nnd*ndg)

#全体マトリクスへの重合
    for ip in range(nnd):
        for i in range(ndg):
            ie = ndg*ip+i
            ig = ndg*indv[n][ip]+i
            for jp in range(nnd):
                for j in range(ndg):
                    je = ndg*jp+j
                    jg = ndg*indv[n][jp]+j
                    kg[ig][jg] = kg[ig][jg] + TkT[ie][je]

#変位拘束点以外の行列の抽出
ic = 0
for i in range(nod*ndg):
    if idg[i]==0:
        ic = ic+1

kgc = []
kgc = mat(kgc,ic,ic,0.0)
fgc = []
fgc = vec(fgc,ic,0.0)
dgc = []
dgc = vec(dgc,ic,0.0)

ic = -1
for i in range(nod*ndg):
    if idg[i]==0:
        ic = ic+1
        fgc[ic]=fg[i]
        jc = -1
        for j in range(nod*ndg):
            if idg[j]==0:
                jc = jc + 1
                kgc[ic][jc]=kg[i][j]

#連立方程式の解法
dgc = solveSE(kgc,fgc,ic+1)

#節点変位の出力
dg = []
dg = vec(dg,nod*ndg,0.0)
ic = -1
for i in range(nod*ndg):
    if idg[i] == 0 :
        ic = ic + 1
        dg[i] = dgc[ic]

fileout.write('\n')
s = '-- displacement --'
print(s)
fileout.write(s)
fileout.write('\n')
tl = 'Nod no.'+'      u      ' + '     v     '+ '     th     '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nod):
    s = str(' %5d' % (i+1))+str('  %10.3e' % dg[ndg*i+0])+str('  %10.3e' % dg[ndg*i+1]) \
        +str('  %10.3e' % dg[ndg*i+2])
    print(s)
    fileout.write(s)
    fileout.write('\n')

#応力（断面力）計算と出力

s = '-- Stress --'
print(s)
fileout.write(s)
fileout.write('\n')
tl = 'Elm no.'+'      N           Qi           Qj           Mi           Mj           Mc'
print(tl)
fileout.write(tl)
fileout.write('\n')

for n in range(nel):
    i1 = indv[n][0]
    i2 = indv[n][1]
    L = math.sqrt((X[i2]-X[i1]) ** 2 + (Y[i2]-Y[i1]) ** 2)
    cs = (X[i2]-X[i1])/L
    sn = (Y[i2]-Y[i1])/L
    ui = cs * dg[ndg * i1 + 0] + sn * dg[ndg * i1 + 1]
    uj = cs * dg[ndg * i2 + 0] + sn * dg[ndg * i2 + 1]
    fxi = E * A[n] / L * (ui - uj)
    Nf = - fxi
    vi = -sn * dg[ndg * i1 + 0] + cs * dg[ndg * i1 + 1]
    ti = dg[ndg * i1 + 2]
    vj = -sn * dg[ndg * i2 + 0] + cs * dg[ndg * i2 + 1]
    tj = dg[ndg * i2 + 2]
    cy = E * Iz[n] / L ** 3
    fyi = 12.0 * cy * vi + 6.0 * L * cy * ti - 12.0 * cy * vj + 6.0 * L * cy * tj
    fyj =-12.0 * cy * vi - 6.0 * L * cy * ti + 12.0 * cy * vj - 6.0 * L * cy * tj
    fyi = fyi - Q0i[n]
    fyj = fyj - Q0j[n]
    Qi = fyi
    Qj = -fyj
    mzi = 6.0 * L * cy * vi + 4.0 * L ** 2 * cy * ti - 6.0 * L * cy * vj + 2.0 * L ** 2 * cy * tj
    mzj = 6.0 * L * cy * vi + 2.0 * L ** 2 * cy * ti - 6.0 * L * cy * vj + 4.0 * L ** 2 * cy * tj
    mzi = mzi - Cij[n]
    mzj = mzj - Cji[n]
    Mi = -mzi
    Mj =  mzj
    Mc = M0[n] + (Mi + Mj) / 2.0

    s = str(' %5d' % (n+1)) + str('   %10.3e' % Nf) + str('   %10.3e' % Qi)+ str('   %10.3e' % Qj) \
      + str('   %10.3e' % Mi) + str('   %10.3e' % Mj) + str('   %10.3e' % Mc)
    print(s)
    fileout.write(s)
    fileout.write('\n')