import math
#----------------
# 関数の定義
#----------------
# ベクトルの０クリア
def vec(vname, rmax, inval=0):
    vname = [number for number in range(int(rmax))]
    for i in range(int(rmax)):
        vname[int(i)] = inval
    return vname

# マトリクスの０クリア
def mat(mname, rmax1, rmax2, inval=0):
    mname = [number for number in range(int(rmax1))]
    for i in range(int(rmax1)):
        mname[int(i)] = [number for number in range(int(rmax2))]
        for j in range(int(rmax2)):
            mname[int(i)][int(j)] = inval
    return mname

#連立方程式の解法
def solveSE(A,B,n):
    n1 = n - 1
    if n1 == 0 :
        B[0]=B[0]/A[0][0]
        return B
    for k in range(n1):
        k1 = k + 1
        s = A[k][k]
        for j in range(k1,n):
            A[k][j] = A[k][j]/s
        B[k] = B[k]/s
        for i in range(k1,n):
            c = A[i][k]
            for j in range(k1,n):
                A[i][j] = A[i][j] - c*A[k][j]
            B[i] = B[i] - c*B[k]
    B[n-1] = B[n-1]/A[n-1][n-1]
    for m in range(n1):
        k = (n-1) - (m+1)
        k1 = k + 1
        for j in range(k1,n):
            B[k] = B[k] - A[k][j]*B[j]
    return B

# 行列のかけ算
def mat_multi(C,A,B,n):
    for i in range(n):
        for j in range(n):
            s = 0.0
            for k in range(n):
                s = s + A[i][k]*B[k][j]
            C[i][j] = s
    return C

# 転置行列
def mat_T(C,A,n):
    for i in range(n):
        for j in range(n):
            C[j][i] = A[i][j]
    return C

# マトリクスとベクトルのかけ算
def mat_vec(C,A,B,n):
    for i in range(n):
        s = 0.0
        for j in range(n):
            s = s + A[i][j]*B[j]
        C[i] = s
    return C

#座標変換マトリクス
def Trmat(cs,sn):
    Tr[0][0] = cs
    Tr[0][1] = sn
    Tr[1][0] = -sn
    Tr[1][1] = cs
    Tr[2][2] = 1.0
    Tr[3][3] = cs
    Tr[3][4] = sn
    Tr[4][3] = -sn
    Tr[4][4] = cs
    Tr[5][5] = 1.0
    return Tr

#要素剛性マトリクス
def Kemat(cx,ri,rj,rb,cy6):
    ke[0][0] = cx
    ke[0][3] = -cx
    ke[3][0] = -cx
    ke[3][3] = cx
    ke[1][1] = cy6*(ri+rj+4.0*ri*rj)/rb
    ke[1][2] = cy6*ri*(1.0+2.0*rj)*L/rb
    ke[1][4] = -ke[1][1]
    ke[1][5] = cy6*(1.0+2.0*ri)*rj*L/rb
    ke[2][1] = ke[1][2]
    ke[2][2] = cy6*ri*(1.0+rj)*L**2/rb
    ke[2][4] = -ke[2][1]
    ke[2][5] = cy6*ri*rj*L**2/rb
    ke[4][1] = ke[1][4]
    ke[4][2] = ke[2][4]
    ke[4][4] = ke[1][1]
    ke[4][5] = -ke[1][5]
    ke[5][1] = ke[1][5]
    ke[5][2] = ke[2][5]
    ke[5][4] = ke[4][5]
    ke[5][5] = cy6*(1.0+ri)*rj*L**2/rb
    return ke
#----------------
# データ入力
#----------------
file = open('input4.txt','r')
fileout = open('output4.txt','w')

nod = file.readline()
nod = int(nod)
ndg = 3

X = []
X = vec(X,nod,0.0)
Y = []
Y = vec(Y,nod,0.0)
idg = []
idg = vec(idg,nod*ndg,0)
fg = []
fg = vec(fg,nod*ndg,0.0)
dg = []
dg = vec(dg,nod*ndg,0.0)
dt = []
dt = vec(dt,nod*ndg,0.0)
kg = []
kg = mat(kg,nod*ndg,nod*ndg,0.0)

#座標入力
for i in range(nod):
   xd = file.readline()
   d1,d2 = xd.split(',')
   X[i] = float(d1)
   Y[i] = float(d2)

#拘束情報の入力
ncn = file.readline()
ncn = int(ncn)
for i in range(ncn):
    bcn = file.readline()
    icn,ic1,ic2,ic3 = bcn.split(',')
    icn = int(icn)
    idg[ndg*(icn-1)+0] = int(ic1)
    idg[ndg*(icn-1)+1] = int(ic2)
    idg[ndg*(icn-1)+2] = int(ic3)

#荷重情報の入力
nld = file.readline()
nld = int(nld)
for i in range(nld):
    fd = file.readline()
    ild,f1,f2,f3 = fd.split(',')
    ild = int(ild)
    fg[ndg*(ild-1)+0] = float(f1)
    fg[ndg*(ild-1)+1] = float(f2)
    fg[ndg*(ild-1)+2] = float(f3)

#*** 要素情報の入力 ***
nel = file.readline()
nel = int(nel)
nnd = 2

indv = []
indv = mat(indv,nel,nnd,0)
A = []
A = vec(A,nel,0.0)
Iz = []
Iz = vec(Iz,nel,0.0)
Mp = []
Mp = vec(Mp,nel,0.0)
Lambda = []
Lambda = mat(Lambda,nel,nnd,0.0)
st = []
st = mat(st,nel,ndg*nnd,0.0)

#要素のi端とj端の節点番号の入力
for i in range(nel):
    ind = file.readline()
    i1,i2 = ind.split(',')
    indv[i][0] = int(i1) - 1
    indv[i][1] = int(i2) - 1

#ヤング係数の入力
E = file.readline()
E = float(E)

#断面積、断面２次モーメント、全塑性モーメントの入力
for i in range(nel):
    s = file.readline()
    s1,s2,s3 = s.split(',')
    A[i] = float(s1)
    Iz[i] = float(s2)
    Mp[i] = float(s3)

file.close()

#入力データの出力
tl = 'Nod no.'+'      x      ' + '     y     '+'   bcx   bcy  bcth    '+'    fx         fy         M'
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nod):
    s = str((' %5d' % (i+1)))+str('  %10.3e' % X[i])+str('  %10.3e' % Y[i])  \
      + str(' %5d' % idg[ndg*i+0]) + str(' %5d' % idg[ndg*i+1]) + str(' %5d' % idg[ndg*i+2])  \
      + str('    %10.3e' % fg[ndg*i+0]) + str(' %10.3e' % fg[ndg*i+1]) + str(' %10.3e' % fg[ndg*i+2])
    print(s)
    fileout.write(s)
    fileout.write('\n')

tl = 'Elm no.'+'    i     ' + ' j   '+'    E    '+'       A     '+'      Iz     '+'    Mp   '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nel):
    s = str(' %5d' % (i+1)) + str(' %5d' % (indv[i][0]+1)) + str('  %5d' % (indv[i][1]+1)) \
    + str('  %10.3e' % E) + str('  %10.3e' % A[i]) + str('  %10.3e' % Iz[i]) + str('  %10.3e' % Mp[i])
    print(s)
    fileout.write(s)
    fileout.write('\n')

#----------------------
# 初期化と繰り返し計算
#----------------------

for i in range(nel):
    for j in range(nnd):
        Lambda[i][j]=1.0
nst = 0
jst = 0
dst = 0.0
dmax1 = 0.0
dmax  = 0.0

for istep in range(10000):
    #----------------
    # 有限要素解析
    #----------------
    #全体剛性マトリクスの作成

    kg = []
    kg = mat(kg, nod * ndg, nod * ndg, 0.0)
    ke = []
    ke = mat(ke, nnd * ndg, nnd * ndg, 0.0)
    Tr = []
    Tr = mat(Tr, nod * ndg, nod * ndg, 0.0)
    TrT = []
    TrT = mat(TrT, nod * ndg, nod * ndg, 0.0)
    Tke = []
    Tke = mat(Tke, nod * ndg, nod * ndg, 0.0)
    TkT = []
    TkT = mat(TkT, nod * ndg, nod * ndg, 0.0)

    for n in range(nel):
        i1 = indv[n][0]
        i2 = indv[n][1]
        L = math.sqrt((X[i2]-X[i1]) ** 2 + (Y[i2]-Y[i1]) ** 2)
        cs = (X[i2]-X[i1])/L
        sn = (Y[i2]-Y[i1])/L
    #座標変換マトリクス
        Tr=Trmat(cs,sn)
    #要素剛性マトリクス
        cx = E * A[n] / L
        ri = Lambda[n][0]
        rj = Lambda[n][1]
        rb = 1.0 +ri + rj
        cy6 = 6.0 * E * Iz[n] / L ** 3
        ke = Kemat(cx,ri,rj,rb,cy6)

    #座標変換
        TrT = mat_T(TrT, Tr, nnd * ndg)
        Tke = mat_multi(Tke, TrT, ke, nnd * ndg)
        TkT = mat_multi(TkT, Tke, Tr, nnd * ndg)

    #全体マトリクスへの重合
        for ip in range(nnd):
            for i in range(ndg):
                ie = ndg*ip+i
                ig = ndg*indv[n][ip]+i
                for jp in range(nnd):
                    for j in range(ndg):
                        je = ndg*jp+j
                        jg = ndg*indv[n][jp]+j
                        kg[ig][jg] = kg[ig][jg] + TkT[ie][je]

    #変位拘束点以外の行列の抽出
    ic = 0
    for i in range(nod*ndg):
        if idg[i]==0:
            ic = ic+1

    kgc = []
    kgc = mat(kgc, ic, ic, 0.0)
    fgc = []
    fgc = vec(fgc, ic, 0.0)
    dgc = []
    dgc = vec(dgc, ic, 0.0)

    ic = -1
    for i in range(nod*ndg):
        if idg[i]==0:
            ic = ic+1
            fgc[ic]=fg[i]
            jc = -1
            for j in range(nod*ndg):
                if idg[j]==0:
                    jc = jc + 1
                    kgc[ic][jc]=kg[i][j]

    #連立方程式の解法
    dgc = solveSE(kgc, fgc, ic + 1)

    #節点変位
    dg = []
    dg = vec(dg,nod*ndg,0.0)
    ic = -1
    for i in range(nod*ndg):
        if idg[i] == 0 :
            ic = ic + 1
            dg[i] = dgc[ic]

    #荷重倍率の計算
    de = []
    de = vec(de,nnd*ndg,0.0)
    dge = []
    dge = vec(dge,nnd*ndg,0.0)
    ste = []
    ste = vec(ste,nnd*ndg,0.0)

    rmini = 10.0 ** 50

    for n in range(nel):
        i1 = indv[n][0]
        i2 = indv[n][1]
        L = math.sqrt((X[i2]-X[i1]) ** 2 + (Y[i2]-Y[i1]) ** 2)
        cs = (X[i2]-X[i1])/L
        sn = (Y[i2]-Y[i1])/L
    #座標変換マトリクス
        Tr = Trmat(cs, sn)
        for i in range(ndg):
            dge[i]=dg[ndg*i1+i]
            dge[i+ndg]=dg[ndg*i2+i]
        de = mat_vec(de,Tr,dge,nnd*ndg)
        if Lambda[n][0] < 0.0000001 :  de[2] = 0.0
        if Lambda[n][1] < 0.0000001 :  de[5] = 0.0
        # 要素剛性マトリクス
        cx = E * A[n] / L
        ri = Lambda[n][0]
        rj = Lambda[n][1]
        rb = 1.0 + ri + rj
        cy6 = 6.0 * E * Iz[n] / L ** 3
        ke = Kemat(cx, ri, rj, rb, cy6)
        #応力ベクトル
        ste = mat_vec(ste,ke,de,nnd*ndg)
        #荷重倍率
        if istep == 0 :
            rmi = rmini
            rmj = rmini
            if abs(ste[2]) > 0.00000001: rmi = Mp[n] / abs(ste[2])
            if abs(ste[5]) > 0.00000001: rmj = Mp[n] / abs(ste[5])
            if rmi < rmini : rmini = rmi
            if rmj < rmini : rmini = rmj
        else:
            if abs(ste[2]) > 0.00000001:
                if n == nst and jst == 0: rmini = dst / abs(ste[2])
            if abs(ste[5]) > 0.00000001:
                if n==nst and jst==1: rmini = dst/abs(ste[5])

    #節点変位の更新
    for i in range(nod*ndg):
        dg[i] = dg[i]*rmini
        dt[i] = dt[i] + dg[i]
    #要素応力の更新
    dst = 10.0 ** 50
    for n in range(nel):
        i1 = indv[n][0]
        i2 = indv[n][1]
        L = math.sqrt((X[i2]-X[i1]) ** 2 + (Y[i2]-Y[i1]) ** 2)
        cs = (X[i2]-X[i1])/L
        sn = (Y[i2]-Y[i1])/L
    #座標変換マトリクス
        Tr = Trmat(cs, sn)
        for i in range(ndg):
            dge[i]=dg[ndg*i1+i]
            dge[i+ndg]=dg[ndg*i2+i]
        de = mat_vec(de,Tr,dge,nnd*ndg)
        if Lambda[n][0] < 0.0000001 :  de[2] = 0.0
        if Lambda[n][1] < 0.0000001 :  de[5] = 0.0
        # 要素剛性マトリクス
        cx = E * A[n] / L
        ri = Lambda[n][0]
        rj = Lambda[n][1]
        rb = 1.0 + ri + rj
        cy6 = 6.0 * E * Iz[n] / L ** 3
        ke = Kemat(cx, ri, rj, rb, cy6)
        #応力ベクトル
        ste = mat_vec(ste, ke, de, nnd * ndg)
        for i in range(nnd*ndg):
            st[n][i] = st[n][i] + ste[i]
        # 次のヒンジ発生節点の探査
        dmi = Mp[n]-abs(st[n][2])
        dmj = Mp[n]-abs(st[n][5])
        if dmi > 0.000001 and dmi < dst :
                dst = dmi
                nst = n
                jst = 0
        if dmj > 0.000001 and dmj < dst :
                dst = dmj
                nst = n
                jst = 1
        #ヒンジ発生位置の更新
        if istep == 0 :
            if abs(ste[2]) > 0.0000001:
                rmi = Mp[n]/abs(ste[2])
                if abs(rmi-1.0) < 0.0000001: Lambda[n][0] = 0.0
            if abs(ste[5]) > 0.0000001:
                rmj = Mp[n]/abs(ste[5])
                if abs(rmj-1.0) < 0.0000001: Lambda[n][1] = 0.0
        else:
            if abs(ste[2]) > 0.0000001:
                rmi = Mp[n]/abs(st[n][2])
                if abs(rmi-1.0) < 0.0000001: Lambda[n][0] = 0.0
            if abs(ste[5]) > 0.0000001:
                rmj = Mp[n]/abs(st[n][5])
                if abs(rmj-1.0) < 0.0000001: Lambda[n][1] = 0.0
    #終了判定
    if istep == 0:
        dmax1 = 0.0
        for i in range(nod):
            if abs(dt[ndg*i+0]) > dmax1: dmax1 = abs(dt[ndg*i+0])
    else:
        dmax = 0.0
        for i in range(nod):
            if abs(dt[ndg*i+0]) > dmax: dmax = abs(dt[ndg*i+0])

    if dmax > dmax1*100.0: break

    #変位と応力の出力
    fileout.write('\n')
    s = 'Step = ' + str(' %5d' % (istep+1))
    print(s)
    fileout.write(s)
    fileout.write('\n')
    s = '-- displacement --'
    print(s)
    fileout.write(s)
    fileout.write('\n')
    tl = 'Nod no.'+'      u      ' + '     v     '+ '     th     '
    print(tl)
    fileout.write(tl)
    fileout.write('\n')
    for i in range(nod):
        s = str(' %5d' % (i+1))+str('  %10.3e' % dt[ndg*i+0])+str('  %10.3e' % dt[ndg*i+1]) \
            +str('  %10.3e' % dt[ndg*i+2])
        print(s)
        fileout.write(s)
        fileout.write('\n')

    #応力（断面力）計算と出力

    s = '-- Stress --'
    print(s)
    fileout.write(s)
    fileout.write('\n')
    tl = 'Elm no.'+'      N           Qi           Qj           Mi           Mj  '
    print(tl)
    fileout.write(tl)
    fileout.write('\n')

    for n in range(nel):
        Nf = -st[n][0]
        Qi = st[n][1]
        Qj = -st[n][4]
        Mi = -st[n][2]
        Mj =  st[n][5]

        s = str(' %5d' % (n+1)) + str('   %10.3e' % Nf) + str('   %10.3e' % Qi)+ str('   %10.3e' % Qj) \
          + str('   %10.3e' % Mi) + str('   %10.3e' % Mj)
        print(s)
        fileout.write(s)
        fileout.write('\n')